/**\file cmsapi.h
  *corecms ͷļ
  *\copyright 2007-2020Ϊ޹˾
  *\author z00192937
  *\date  2012-2-8
*/
#ifndef __ATP_CMS_API_H__
#define __ATP_CMS_API_H__

#ifdef __cplusplus
extern "C" {
#endif

extern ATP_THREAD_SAFE VOS_UINT32 g_ulCmsErrCode;
extern VOS_BOOL g_bCmsDbInited;

typedef enum tagATP_CMS_RET_CODE_EN
{
    ATP_CMS_RET_INTERNAL_ERR        = ATP_MNT_ERR_CODE_DEF(ATP_TEAM_MNT, ATP_MODULE_CMS),
    ATP_CMS_RET_PARA_ERR,
    ATP_CMS_RET_APPNAME_ERR,
    ATP_CMS_RET_MEM_ERR,

    ATP_CMS_RET_INVALID_VALUE,

    // 9001

    // 9002

    // 9003

    // 9004
} ATP_CMS_RET_CODE_EN;

#define ATP_CMS_MAX_INST_NUM        (256)
/**********************h00190880*********************/

#define VDB_DB_STATUS           "/var/vdb.status"
//DTS2011083002249
#define VDB_VDB_WRITE_STATUS    "/var/vdb.write"

/**********************h00190880*********************/

/*
 *  Add and Del function proc
 */
typedef VOS_UINT32 (*CmsDelObjProc)(
                            const VOS_UINT32 aucInstId[ATP_CFM_MAX_TREE_DEPTH],
                            VOS_UINT32 ulObjID);

typedef VOS_UINT32 (*CmsCheckSingleObjProc)(
                            const VOS_UINT32 aucInstId[ATP_CFM_MAX_TREE_DEPTH],
                            VOS_UINT32 ulObjId, const VOS_UINT32 *pulOldValues,
                            VOS_UINT32 *pulSetValues, const VOS_UINT32 *pulChgParas,
                            VOS_UINT32 ulNumOfPara);

typedef VOS_UINT32 (*CmsCheckObjProc)(
                            const VOS_UINT32 aucInstId[ATP_CFM_MAX_TREE_DEPTH],
                            VOS_UINT32 ulObjId, const VOS_UINT32 *pulOldValues,
                            VOS_UINT32 *pulSetValues, const VOS_UINT32 *pulChgParas,
                            VOS_UINT32 ulNumOfPara, VOS_BOOL bSetObj);

typedef VOS_UINT32 (*CmsSetSingleObjProc)(
                            const VOS_UINT32 aucInstId[ATP_CFM_MAX_TREE_DEPTH],
                            VOS_UINT32 ulObjId, const VOS_UINT32 *pulOldValues,
                            VOS_UINT32 *pulSetValues, const VOS_UINT32 *pulChgParas,
                            VOS_UINT32 ulNumOfPara, VOS_UINT32 ulNextObjId);

typedef VOS_UINT32 (*CmsAddSetObjProc)(
                            const VOS_UINT32 aucInstId[ATP_CFM_MAX_TREE_DEPTH],
                            VOS_UINT32 ulObjId, const VOS_UINT32 *pulOldValues,
                            VOS_UINT32 *pulSetValues, const VOS_UINT32 *pulChgParas,
                            VOS_UINT32 ulNumOfPara, VOS_UINT32 ulNextObjId, VOS_BOOL bSetObj);

typedef VOS_UINT32 (*CmsGetObjProc)(
                            const VOS_UINT32 aucInstId[ATP_CFM_MAX_TREE_DEPTH],
                            VOS_UINT32 ulObjId, VOS_UINT32 *pulGetdValues,
                            const VOS_UINT32 *pulFocusParas,
                            VOS_UINT32 ulNumOfPara);

typedef VOS_UINT32 (*CmsGetInstProc)(
                            const VOS_UINT32 aucInstId[ATP_CFM_MAX_TREE_DEPTH],
                            VOS_UINT32 ulObjId, VOS_UINT32 *pulInstValues,
                            VOS_UINT32 ulArrayLen, VOS_UINT32 *pulNumOfInst);

typedef struct tagATP_CMS_MULTI_INST_OBJ_ST
{
    VOS_UINT32          ulMaxInstNum;
    CmsCheckObjProc     pfCheckProc;
    CmsAddSetObjProc    pfAddSetProc;
    CmsDelObjProc       pfDelProc;
} ATP_CMS_MULTI_INST_OBJ_ST;

typedef struct tagATP_CMS_GET_OBJ_ST
{
    CmsGetObjProc       pfGetProc;
    CmsGetInstProc      pfGetInstProc;
} ATP_CMS_GET_OBJ_ST;

typedef struct tagATP_CMS_SET_SINGLE_OBJ_ST
{
    CmsCheckSingleObjProc   pfCheckProc;
    CmsSetSingleObjProc     pfSetSingleObjProc;
} ATP_CMS_SET_SINGLE_OBJ_ST;

typedef VOS_UINT32  (*pfDoAfterCmsInit)(VOS_VOID* pvArg);
typedef VOS_VOID    (*pfArgFree)(VOS_VOID*  pvArg);

typedef struct tagATP_CMS_AFTER_INIT_CALL
{    
    struct tagATP_CMS_AFTER_INIT_CALL*  pstNext;
    
    pfDoAfterCmsInit    pfCallBack;
    VOS_VOID*           pvArg;
    pfArgFree           pfFree;
}ATP_CMS_AFTER_INIT_CALL;

extern VOS_BOOL g_bInited;
VOS_UINT32 ATP_CMS_SigRtSigInit(VOS_VOID);
VOS_UINT32 ATP_CMS_AddAfterCmsInitCallback(pfDoAfterCmsInit pfDoAfter, 
                                           VOS_VOID*        pvArg,
                                           pfArgFree        pfFree);

VOS_UINT32 ATP_CMS_DoAfterModuleInit(VOS_VOID);

VOS_UINT32 ATP_CMS_RegGetObj(const VOS_CHAR *pcObjName, const ATP_CMS_GET_OBJ_ST *pstObj);
VOS_UINT32 ATP_CMS_RegSObj(const VOS_CHAR *pcObjName, const ATP_CMS_SET_SINGLE_OBJ_ST *pstSObj);
VOS_UINT32 ATP_CMS_RegMObj(const VOS_CHAR *pcObjName, const ATP_CMS_MULTI_INST_OBJ_ST *pstMObj);

typedef struct tagATP_CMS_MSG_HDL_LIST_ST
{
    struct tagATP_CMS_MSG_HDL_LIST_ST   *pstNext;
    VOS_UINT32                          ulMsgType;
    VOS_UINT32                          ulPriority;
    AtpMsgProc                          pfProc;
} ATP_CMS_MSG_HDL_LIST_ST;

#define ATP_CMS_MSG_PRIORITY_DEFAULT_D          (0x5000)
#define ATP_CMS_MSG_PRIORITY_STEP_D             (0x0100)

VOS_UINT32 ATP_CMS_RegMsgProc(VOS_UINT32 ulMsgType, AtpMsgProc pfProc,
                    VOS_UINT32 ulPriority, ATP_CMS_MSG_HDL_LIST_ST **ppstMsgHdl);

VOS_VOID ATP_CMS_UnRegMsgProc(ATP_CMS_MSG_HDL_LIST_ST *ppstMsgHdl);

VOS_VOID ATP_CMS_DoMsgProc(const ATP_MSG_HEADER_ST *pstMsg);

//!for gmsg

typedef VOS_VOID   (*PFMgntModuleGMsgProc)(VOS_VOID *pvGMsg, VOS_UINT32 ulSubType);

typedef struct tagATP_CMS_GMSG_HDL_LIST_ST
{
    struct tagATP_CMS_GMSG_HDL_LIST_ST   *pstNext;
    VOS_CHAR    pcModName[16];
    VOS_UINT32  ulMsgType;
    PFMgntModuleGMsgProc    pfProc;
} ATP_CMS_GMSG_HDL_LIST_ST;

VOS_VOID ATP_CMS_DoGMsgProc(const ATP_MSG_HEADER_ST *pvGMsg);
VOS_UINT32 ATP_CMS_RegGMsgProc(VOS_CHAR * pszModName, PFMgntModuleGMsgProc pfProc, ATP_CMS_GMSG_HDL_LIST_ST **ppstMsgHdl);
VOS_VOID ATP_CMS_UnRegGMsgProc(ATP_CMS_GMSG_HDL_LIST_ST *ppstMsgHdl);

/******************************************************************************
    : ATP_CMS_Init
    : ʼCMSеĸģ
    : 
              
  ú  : 
    : 
    : 
    ֵ  : 

  ޸ʷ      :
   1.       : 2008-12-16
            : z65940
     ޸   : ɳ

******************************************************************************/
VOS_UINT32 ATP_CMS_Init(VOS_VOID);

/******************************************************************************
    : ATP_CMS_UnInit
    : ȥʼCMSеĸģ
    : 
              
  ú  : 
    : 
    : 
    ֵ  : 

  ޸ʷ      :
   1.       : 2008-12-16
            : z65940
     ޸   : ɳ

******************************************************************************/
VOS_UINT32 ATP_CMS_UnInit(VOS_VOID);
VOS_UINT32 ATP_CMS_MonitorCreate(VOS_VOID);

extern ATP_THREAD_SAFE ATP_CFM_E_IF_TYPE g_enCfgTool;

VOS_VOID ATP_CMS_AddSetMsgProc(const ATP_MSG_HEADER_ST *pstMsg);

VOS_VOID ATP_CMS_GetMsgProc(const ATP_MSG_HEADER_ST *pstMsg);

VOS_VOID ATP_CMS_GetInstMsgProc(const ATP_MSG_HEADER_ST *pstMsg);

VOS_VOID ATP_CMS_AddMsgProc(const ATP_MSG_HEADER_ST *pstMsg);

VOS_VOID ATP_CMS_DelMsgProc(const ATP_MSG_HEADER_ST *pstMsg);

typedef VOS_VOID (* PFCmsSetMsgHooks)(VOS_VOID *pvData);

VOS_UINT32 ATP_CMS_RegSetMsgHook(PFCmsSetMsgHooks pfSetHook, VOS_VOID *pvData);

// Will not override, you can register the same function several times, and it will be executed serveral times
VOS_UINT32 ATP_CMS_RegSetMsgHookEx(PFCmsSetMsgHooks pfSetHook, VOS_VOID *pvData);
    
VOS_UINT32 ATP_CMS_RegCwmpEndSessionHook(PFCmsSetMsgHooks pfEndSessionHook, VOS_VOID *pvData);

VOS_VOID ATP_CMS_CwmpSessionEndMsgProc(const ATP_MSG_HEADER_ST *pvMsg);

VOS_UINT32 ATP_CMS_GetObj(const VOS_UINT32   ulKeyList[ATP_CFM_MAX_TREE_DEPTH],
                                 VOS_UINT32   ulOID,
                                 VOS_UINT32   **ppulObj);
/*
 *  Version utilities
 */
typedef const VOS_CHAR * (*PfAtpGetVersion)();
void ATP_CMS_GeneralPrintVersion(const VOS_CHAR *pcModName, PfAtpGetVersion pfnGetVersion);

#if 0
const char * ATP_CMSCORE_GetVersion(void);                         
#endif

VOS_UINT32 ATP_CMS_UpdateDynAppListenFd(const VOS_CHAR * pcAppName, VOS_BOOL bStop);
/*********************h00190880********************/
typedef VOS_UINT32 (*CmsGlobalCheckPara)();
/*********************h00190880********************/

#ifdef SUPPORT_ATP_DECT_VOICE
extern void *g_pvVdbVoiceHdl;
extern void *g_pvDummyDbHdl;
#endif
/************************************************************************************************************************************/
/*Common Functions for cms*/
/**/
#define ATP_SYS_BITS_MAX                    8
#define ATP_SYS_TINY_LEN                    16
#define ATP_SYS_CMD_LEN                     512
#define ATP_SYS_SMALL_LEN                   32
#define ATP_SYS_LARGE_LEN                   264
#define ATP_SYS_GIANT_LEN                   1024

/*String Safe Length*/
#define ATP_STRING_LEN_128                  132   
#define ATP_STRING_LEN_16                   20    
#define ATP_STRING_LEN_8                    12
#define ATP_STRING_LEN_2                    4

/*String Actual Length*/
#define ATP_ACTUAL_LEN_32                   32 
#define ATP_ACTUAL_LEN_16                   16


/*IP*/
#define ATP_SYS_IP_BYTE                     4
#define ATP_SYS_IP_BYTE_FIRST               0
#define ATP_SYS_IP_BYTE_SECOND              1
#define ATP_SYS_IP_BYTE_THIRD               2
#define ATP_SYS_IP_BYTE_FOUR                3
#define ATP_SYS_IP_DOT_LENGTH               19
#define ATP_SYS_IP_LENGTH                   16
#define ATP_SYS_IP_LOCAL_FIRST              127
#define ATP_SYS_IP_MAX_NUMBER               255
#define ATP_SYS_IP_MIN_NUMBER               0
#define ATP_SYS_IP_MULTI_FIRST_MAX          239
#define ATP_SYS_IP_MULTI_FIRST_MIN          224
#define ATP_SYS_IP_TBL_COL_NUM              0
#define ATP_SYS_IP_TBL_COL_MIN              2
#define ATP_SYS_IP_TBL_COL_PKTS             1
#define ATP_SYS_IP_TBL_COL_BYTES            2
#define ATP_SYS_IP_TBL_COL_TARGET           3
#define ATP_SYS_IP_TBL_COL_PROT             4
#define ATP_SYS_IP_TBL_COL_OPT              5
#define ATP_SYS_IP_TBL_COL_IN               6
#define ATP_SYS_IP_TBL_COL_OUT              7
#define ATP_SYS_IP_TBL_COL_SRC              8
#define ATP_SYS_IP_TBL_COL_DST              9
#define ATP_SYS_IP_TBL_COL_MAX              10

/*Route*/
#define ATP_ROUTE_DEF_COL                   11
#define ATP_ROUTE_DEF_COL_MIN               1
#define ATP_ROUTE_DEF_COL_FIRST             0
#define ATP_ROUTE_DEF_COL_SECOND            1
#define ATP_ROUTE_DEF_COL_THIRD             2
#define ATP_ROUTE_DEF_COL_FOUR              3
#define ATP_ROUTE_DEF_COL_FIVE              4
#define ATP_ROUTE_DEF_COL_SIX               5
#define ATP_ROUTE_DEF_COL_SEVEN             6
#define ATP_ROUTE_DEF_COL_EIGHT             7
#define ATP_ROUTE_DEF_COL_NINE              8
#define ATP_ROUTE_DEF_COL_TEN               9
#define ATP_ROUTE_DEF_COL_ELEVEN            10
#define ATP_ROUTE_DEF_FLAG                  "00000000"


/**/
#define ATP_SYS_BASE_DEC                    10
#define ATP_SYS_BASE_HEX                    16

/*MAC*/
#define ATP_SYS_MAC_BYTE                    6
#define ATP_SYS_MAC_LENGTH                  18
#define ATP_SYS_MAC_MAX_NUMBER              255

/*Time*/
#define ATP_SYS_TIME_HOUR_MAX               23
#define ATP_SYS_TIME_LENGTH                 5
#define ATP_SYS_TIME_MINUTE_MAX             59
#define ATP_SYS_TIME_PART_LEN               2 //жʱַ":"ǰĳ

/*LAN*/
#define ATP_LAN_MAX                         4
#define ATP_LAN_ENET_ID	                    1
#define ATP_LAN_USB_ID		                  (ATP_LAN_ENET_ID + ATP_LAN_MAX)
#define ATP_LAN_HPNA_ID		                  (ATP_LAN_USB_ID + ATP_LAN_MAX)
#define ATP_LAN_WIRELESS_ID		              (ATP_LAN_HPNA_ID + ATP_LAN_MAX)
#define ATP_LAN_SUBNET_ID                   (ATP_LAN_WIRELESS_ID + ATP_LAN_MAX) 
#define ATP_LAN_ENET0_VNET_ID               (ATP_LAN_SUBNET_ID + ATP_LAN_MAX)
#define ATP_LAN_ENET1_VNET_ID               (ATP_LAN_ENET0_VNET_ID + ATP_LAN_MAX)

/*Time*/
#define ATP_UTIL_MSleep(x)                  usleep((x)*1000)

/*Interface*/
/* WAN type by w00165788 20120314 */
#define ATP_WAN_DSL_TYPE                    "DSL"
#define ATP_WAN_ETH_TYPE                    "Ethernet"
#define ATP_WAN_POT_TYPE                    "POTS"
#define ATP_WAN_UMTS_TYPE                  "UMTS"



/*start added by l00184769 for compare func*/
#define VOS_BIG                             1
#define VOS_SMALL                           (-1)
#define VOS_EQUAL                           0
#define VOS_ERROR_COMPARE                   (-2)
/*end added by l00184769 for compare func*/

#ifdef ATP_DEBUG
#define ATP_DEBUG_Outputf(x...)
#else
#define ATP_DEBUG_Outputf(x...)
#endif


/*һ.Valid Function*/
/*0.Public Valid*/
/*!
  \brief  Уֵַֻ
  \param[in]  pcBuf: Уַ
  \param[in]  isAllowZeroStart: ipַǷ0ͷ
  \return *pcBufǷǿղֵַֻ
  \retval VOS_TRUE  *pcBuf ֵַ
  \retval VOS_FALSE *pcBuf Ϊջֵַ߲
*/
VOS_BOOL ATP_UTIL_ValidateThreeNumberEx(VOS_CHAR* pcBuf, VOS_BOOL isAllowZeroStart);
/*!
  \brief УַǷΪ
  \param[in]  pcNum: Уַ
  \return*pcNum Ƿ
  \retval VOS_TRUE  *pcNum 
  \retval VOS_FALSE *pcNum 
*/
VOS_BOOL ATP_UTIL_ValidateNumber(VOS_CHAR* pcNum);
/*!
  \brief  жβǷϷ
  \param[in]  lNum: жβ
  \return ǷϷ
  \retval VOS_TRUE  βЧ
  \retval VOS_FALSE βϷ
*/
VOS_BOOL ATP_UTIL_CheckNum(VOS_INT lNum);
/*!
  \brief ֤lValueֵΧ
  \param[in]  lValue: Уֵ
  \param[in]  lMin: Сֵ
  \param[in]  lMax: ֵ
  \return lValue Ƿ[lMin, lMax] 
  \retval VOS_TRUE   lValue [lMin, lMax] 
  \retval VOS_FALSE  lValue [lMin, lMax] 
*/
VOS_BOOL ATP_UTIL_ValidateNumberRange(VOS_INT32 lValue, VOS_INT32 lMin, VOS_INT32 lMax);
/*!
  \brief  ַΧУ
  \param[in]  *pcNum: Уַ
  \param[in]  lMin: УСֵΧ
  \param[in]  lMax: УֵΧ
  \return *pcNumǷ[lMin, lMax]Χ
   \retval VOS_TRUE  *pcNum [lMin, lMax]Χ
  \retval VOS_FALSE *pcNum [lMin, lMax]Χ
*/
VOS_BOOL ATP_UTIL_ValidateRange(VOS_CHAR *pcNum, VOS_INT lMin, VOS_INT lMax);
/*!
  \brief Уַ
  \param[in]  *pszStr: Уַ
  \param[in]  ulMax: Уַ󳤶
  \return *pszStrǷǿգҳulMaxΧ
  \retval VOS_TRUE  *pszStrΪ*pszStrĳulMaxΧ
  \retval VOS_FALSE *pszStrΪջ*pszStrĳȲulMaxΧ
*/
VOS_BOOL ATP_UTIL_ValidateLength(VOS_CHAR *pszStr, VOS_UINT ulMax);

/*1.IP & MASK Valid*/
/*!
  \brief УIpv4 ַ
  \param[in]  *pcIpAddr: ҪУĵַ
  \return *pcIpAddrǷΪIp ַ
  \retval VOS_TRUE *pcIpAddr Ip ַ
  \retval VOS_FALSE *pcIpAddr Ip ַ
*/
VOS_BOOL ATP_UTIL_ValidateIpAddress(VOS_CHAR *pcIpAddr);
/*!
  \brief УIpv4 ַǷΪ㲥ַ
  \param[in]  *pIp: Ip ַ
  \param[in]  *pMask: 
  \return Ip ַǷΪ㲥 ַ
  \retval VOS_TRUE Ip ַ ǹ㲥 ַ
  \retval VOS_FALSE Ip ַ ǹ㲥 ַ
*/
VOS_BOOL ATP_UTIL_ValidateBroadcastIp(VOS_INT *pIp, VOS_INT *pMask);
/*!
  \brief УIpv4ַʽ
  \param[in]  *pValue: Уֵ
  \return *pValueǷΪIpַʽ
  \retval VOS_TRUE  *pValue Ipַʽ
  \retval VOS_FALSE *pValueIpַʽ
*/
VOS_BOOL ATP_UTIL_IsIpFormat(VOS_VOID *pValue);
/*!
  \brief УIpv4 ַǷΪַ
  \param[in]  *pcIpAddr: УIpַ
  \return *pcIpAddrǷΪ ַ
  \retval VOS_TRUE *pcIpAddr  ַ
  \retval VOS_FALSE *pcIpAddr  ַ
*/
VOS_BOOL ATP_UTIL_ValidateHostIpAddress(const VOS_CHAR *pcIpAddr);
/*!
  \brief УIpv4 ַǷΪ鲥ַ
  \param[in]  *pcIpAddr: УIpַ
  \return *pcIpAddrǷΪ鲥ַ
  \retval VOS_TRUE *pcIpAddr 鲥ַ
  \retval VOS_FALSE *pcIpAddr 鲥ַ
*/
VOS_BOOL ATP_UTIL_ValidateMCastIpAddress(const VOS_CHAR *pcIpAddr);
/*!
  \brief УIpv4 ַǷΪdnsַַ
  \param[in]  *pcIpAddr: УIpַ
  \return  *pcIpAddrǷΪdnsַַ
  \retval VOS_TRUE  *pcIpAddr dnsַַ
  \retval VOS_FALSE *pcIpAddr dnsַҲַ
*/
VOS_BOOL ATP_UTIL_ValidateDnsOrHostAddress(const VOS_CHAR *pcIpAddr);
/*!
  \brief УIpv4ǷϷ
  \param[in]  *pcSubnetMask: У
  \return *pcSubnetMaskǷΪ
  \retval VOS_TRUE  *pcSubnetMask 
  \retval VOS_FALSE *pcSubnetMask 
*/
VOS_BOOL ATP_UTIL_ValidateSubnetMask(VOS_CHAR *pcSubnetMask);

/*2.MAC Valid*/
/*!
  \brief УMAC ַ
  \param[in]  *pcMacAddr: УMAC ַ
  \return *pcMacAddrǷΪMAC ַ
  \retval VOS_TRUE  *pcMacAddrMAC ַ  
  \retval VOS_FALSE *pcMacAddrMAC ַ
*/

/* Start of added by f00120964 for qos subnetmask function 2012-4-1*/
extern VOS_BOOL ATP_UTIL_QosValidateSubnetMask(VOS_CHAR *pcSubnetMask);
/*2.SubnetMask Valid*/
/*!
  \brief УSubnetMask ַ
  \param[in]  *pcMacAddr: УSubnetMask ַ
  \return *SubnetMaskǷΪSubnetMask ַ

*/
/* End of added by f00120964 for qos subnetmask function 2012-4-1*/

VOS_BOOL ATP_UTIL_ValidateMacAddress(VOS_CHAR *pcMacAddr);

/*3.IPv6 Valid*/
/*!
  \brief УַǷΪIpv6ַ
  \param[in]  *pcIpv6Addr: Уַ
  \return *pcIpv6AddrǷΪIpv6ַ
  \retval VOS_TRUE *pcIpv6Addr Ipv6ַ
  \retval VOS_FALSE *pcIpv6Addr Ipv6ַ
*/
VOS_BOOL ATP_UTIL_ValidateIpv6Address(const VOS_CHAR *pcIpv6Addr);

/*4.Domain Valid*/
/*!
  \brief УĸʽǷȷ
          1)ֻĸַֺ'-'
          2)'-'ͷ
          3)ַܰ
          4)չӦǾ
          5)ȷҪ
  \param[in]  *pcDomain: У
  \param[in]  ulLen: 
  \return ʽǷȷ
  \retval VOS_TRUE ʽȷ
  \retval VOS_FALSE ʽȷ
*/
VOS_BOOL ATP_UTIL_ValidateDomainName(VOS_CHAR *pcDomain, VOS_UINT ulLen);

/*!
  \brief УǷϷ
          1)ַλascii'!''~'֮
          2)ܳȲ255ǩȲ63
          3)б'.''.'ٿͷĩβ'.'ΪϷ
  \param[in]  *pcDomain: У
  \return ʽǷȷ
  \retval VOS_TRUE ʽȷ
  \retval VOS_FALSE ʽȷ
*/
VOS_BOOL ATP_UTIL_ValidateDomainNameEx(const VOS_CHAR * pcDomain);

/*!
  \brief ˵IPV6ַߵ
  \param[in]  pszValue: 
  \param[in]  acBuf: 
  \param[in]  ulSize: 
  \return 
  \retval ATP_E_ERR_CFM_SHM_NOT_ATTACH ʼڴʧ
*/
VOS_BOOL ATP_UTIL_Ipv6AddressFilter(const VOS_CHAR* pszValue, VOS_CHAR* acBuf, VOS_UINT32 ulSize);

/*!
  \brief ַIPַַУ
          1)ipv4ַʱUtilValidateIpAddressУ
          2)ipv6ַʱUtilValidateIpv6AddressУ
          3)Ȳipv4ֲַipv6ַʱATP_UTIL_ValidateDomainNameExУ
  \param[in]  *pcValue: Уַ
  \return УǷͨ
  \retval VOS_TRUE Уͨ
  \retval VOS_FALSE У鲻ͨ
*/
VOS_BOOL ATP_UTIL_ValidateIpAddressOrDomainName(const VOS_CHAR *pcValue);

/*!
  \brief ַIPַַУ
          1)ipv4ַʱUtilValidateIpAddressУ
          2)ipv6ַʱUtilValidateIpv6AddressУ
          3)Ȳipv4ֲַipv6ַʱATP_UTIL_ValidateDomainNameExУ
  \param[in]  *pcValue: Уַ
  \return УǷͨ
  \retval VOS_TRUE Уͨ
  \retval VOS_FALSE У鲻ͨ
*/
VOS_BOOL ATP_UTIL_ValidateIpAddressOrDomainNameEx(const VOS_CHAR *pcValue);

/*5.Time Valid*/
/*!
  \brief УʱַǷϷ
  \param[in]  pszTime: Уʱַ
  \return *pszTimeǷǿղҺϷ
  \retval VOS_TRUE  *pszTime Ч
  \retval VOS_FALSE *pszTimeΪջ򲻺Ϸ
*/
VOS_BOOL ATP_UTIL_ValidateTime(VOS_CHAR* pszTime);

/*.common call functions*/
/*1.convert & get & set Function*/
/*!
  \brief  IPv4ַת
  \param[in]  *pszIpAddrValue: Ipַ
  \param[out]  *pSplitValue: ת
  \return Ƿתɹ
  \retval VOS_TRUE  תɹ
  \retval VOS_FALSE תʧ
*/
VOS_BOOL ATP_UTIL_IpAddrSplit(VOS_CHAR *pszIpAddrValue, VOS_INT *pSplitValue);

/*2.InterfaceName Function*/
/*!
  \brief  IDȡӿ
  \param[in]  lInterId: ӿID
  \param[out]  *pcInterName: ȡĽӿ
  \return Ƿȡӿɹ
  \retval VOS_TRUE  ȡӿɹ
  \retval VOS_FALSE ȡӿʧ
*/
VOS_INT ATP_UTIL_GetInterfaceNameById(VOS_INT  lInterId, VOS_CHAR *pcInterName);

/*3.Module Function*/
/*!
  \brief УģǷѾ
  \param[in]  *pcModName: Уģ
  \return ǷģѲ
  \retval VOS_TRUE   ģѲ
  \retval VOS_FALSE  ģδ
*/
VOS_BOOL ATP_UTIL_IsModuleInserted(VOS_CHAR *pcModName);
/*!
  \brief ģ
  \param[in]  *pcModName: ģ
  \param[in]  *pcModulePath: ģ·
  \return Ƿ ɹ
  \retval VOS_TRUE  ɹ
  \retval VOS_FALSE ʧ
*/
VOS_BOOL ATP_UTIL_InsertModule(VOS_CHAR *pcModName, VOS_CHAR *pcModulePath);

typedef VOS_UINT32 (*AtpStatusChangeNotifyProc)(VOS_UINT32 ulServiceType, VOS_VOID *pvNotifyData);

/*!
  \brief Status change response interface
  \param[in]  ulServiceType: 
  \param[in]  pfNotifyProc: 
  \return 
  \retval VOS_OKɹ
*/
VOS_UINT32 ATP_STATUS_RegNotifyProc(
                                VOS_UINT32 ulServiceType,
                                AtpStatusChangeNotifyProc pfNotifyProc);

/*!
  \brief Status change notifier interface
  \param[in]  ulServiceType: 
  \param[in]  *pvNotifyData: 
  \return 
  \retval VOS_OKɹ
*/
VOS_UINT32 ATP_STATUS_ChangeNotify(
                                VOS_UINT32 ulServiceType, 
                                VOS_VOID *pvNotifyData);

/*!
  \brief 
  \param[in]  *pcValue: 
  \return 
  \retval 0 ɹ 0 ʧ
*/

VOS_BOOL ATP_UTIL_IsIpv4Format(const VOS_CHAR *pcValue);

/*!
  \brief 
  \param[in]  *pcValue: 
  \return 
  \retval  VOS_OKɹ  VOS_FALSEʧ
*/

VOS_BOOL ATP_UTIL_IsIpv4FormatRepair(const VOS_CHAR *pcValue);

/*!
  \brief 
  \param[in]  *pcValue: 
  \return 
  \retval  VOS_OKɹ  VOS_FALSEʧ
*/

VOS_BOOL ATP_UTIL_IsGlobalIpv6Address(const VOS_CHAR *pcValue);

/*!
  \brief Դ
  \return 
  \retval VOS_OKɹ
*/
VOS_VOID ATP_STATUS_DestroyAllNotify();

VOS_INT32 ATP_UTIL_CompareIpv6Address(const struct in6_addr* pstAddrNew, const struct in6_addr* pstAddrOld);


/******************************************************************************
  ƣWanValidateNumberAlpha
  УַǷa-zA-Z, 0-9
  pszValue 
  
    ֵϷVOS_TRUEǷVOS_FALSE
  ˵
******************************************************************************/
VOS_BOOL ATP_UTIL_ValidateNumberAlpha(const VOS_CHAR* pszValue);
VOS_BOOL  ATP_UTIL_ValidateIpv6AddressEx(const VOS_CHAR * pcIpv6Addr);

/************************************************************************************************************************************/
#ifdef ATP_DEBUG
#define ATP_CMS_DEBUG(format, args...)       {printf("FILE: %s LINE: %d: ", __FILE__, __LINE__);printf(format, ##args);printf("\n");}
#else
#define ATP_CMS_DEBUG(x...)
#endif

#define ATP_CMS_RELEASE(format, args...)     {ATP_MSG_Printf("FILE: %s LINE: %d: ", __FILE__, __LINE__);ATP_MSG_Printf(format, ##args);}

#ifdef SUPPORT_ATP_TRACE_CODE_DEBUG
#define ATP_CMS_TRACE(format, args...)     {printf("FILE: %s LINE: %d: ", __FILE__, __LINE__);printf(format, ##args);}
#else
#define ATP_CMS_TRACE(x...)
#endif

#ifdef __cplusplus
}
#endif

#endif

